// $Id: ball.c 6991 2010-12-02 04:10:59Z suzuki $
// -*-: coding:utf-8; -*-

# include <ball.h>
# include <mighty.h>

gint N_balls = 0;

// gint ballpos[3] = {0, 120, 240}; /* 敵のx座標 */
// gint bi = 0;

gchar *ball_pics[KINDS_OF_BALLS] = 
  {"../images/GreenBall.png", "../images/BlueBall.png", "../images/YellowBall.png"};

void
balls_init(myAnimeArea *area, gint nballs)
{
  gint i;

  for(i=0; i<nballs; i++) 
    {
      ball_new(area);
    }
}

//mySprite *
void
ball_new(myAnimeArea *area)
{
  mySprite *s;

  printf("ball_new (%d)\n", N_balls);
  s = my_sprite_new(area, ball_pics[N_balls%KINDS_OF_BALLS], 30, (GSourceFunc) ball_init, (GSourceFunc)ball_move);
  N_balls++;
}
	 
// スプライトの初期座標とベクトルの設定 
void
ball_init(mySprite *sprite)
{
  myAnimeArea *area = sprite->anime_area;
  GRand *rand = g_rand_new();

  // sprite->x = ballpos[bi];   /* 敵のy座標は3種類 ballposはグローバル */
  sprite->x = 0;
  sprite->y = area->height/2 - sprite->height/2;            /* 敵のy座標固定 */

  // bi = (bi + 1) % 3;

  sprite->dx = 2;            /* 敵の速度はx方向に2固定 */
  //  while((sprite->dy = g_rand_int_range(rand, -5, 5)) == 0);
  g_rand_free(rand);
}

void 
ball_move(mySprite *sprite)
{
  myAnimeArea *area = sprite->anime_area;
  gint x = sprite->x,   y = sprite->y;
  gint dx = sprite->dx, dy = sprite->dy;
  gint width = sprite->width;
  gint height = sprite->height;

  /* スプライトの座標を更新 */
  x += dx; y += dy;
  /* 端まで行ったら跳ね返す */
  if(x < 0)                 { x += 0 - x;                 dx = -dx; }
  if(y < 0)                 { y += 0 - y;                 dy = -dy; }
  if(x > area->width - width)   { x += area->width - width - x;   dx = -dx; }
  if(y > area->height - height) { y += area->height - height - y; dy = -dy; }

  sprite->x = x;   sprite->y = y;
  sprite->dx = dx; sprite->dy = dy;

  if (ball_collision(sprite))
    {
      ball_remove(sprite);
    }
}

gint 
ball_collision(mySprite *self)
{
  gint i;
  for (i = 1; i < N_mighty; i++) {     /* 初期のiが1 (mighty[0]はあたり判定なし) */
    gint lx = abs(self->x-mighty[i]->x);
    gint ly = abs(self->y-mighty[i]->y);
    gint wx = (self->width + mighty[i]->width)/2;
    gint wy = (self->height + mighty[i]->height)/2;
    if (lx<wx&&ly<wy) 
      return TRUE;
    // else
    // return FALSE;
  }
  return FALSE;
}

void ball_remove(mySprite *self)
{
  N_balls--;
  my_sprite_remove(self);
}

gint
ball_is_clicked(gpointer me)
{
  myAnimeArea *b = (mySprite *)me;

  printf("ball_is_clicked!\n");
  ball_new(b);
  return FALSE;
}
