// $Id: ball.h 6991 2010-12-02 04:10:59Z suzuki $
// -*-: coding:utf-8; -*-
# ifndef _UNIT_H_
# define _UNIT_H_

# include <stdlib.h>
# include <gtk/gtk.h>
# include <glib/gprintf.h>
# include <gtk_lib.h>

# include <anime.h>
# include <event.h>

# define KINDS_OF_UNITS 3

extern gint g_ememy_num;
extern gint g_mighty_num;

extern GList *unit_list;

// スプライト
typedef struct { 
  myAnimeArea *anime_area; // のっかっているアニメーション領域
  gint timeout;            // スプライトのタイムアウト */
  GdkPixbuf *pixbuf;       // スプライト用画像（ピクスバッファ）
  gint width;              // 幅
  gint height;             // 高さ
  gint x, y;       		   // 座標
  GSourceFunc move;        // 動きを決める関数

  gint level;
  gint cost;
  gint bullet_type;
} unitSprite;

typedef struct {
	char *pics;
	int cost;
	int bullet_type;
} unitType;

typedef struct {
  gint dx;
  gint dy;
} vector;

void units_init(void);
//mySprite *ball_new(myAnimeArea *area);
void unit_new(myAnimeArea *area, gint x, gint y);
void unit_init(unitSprite *sprite);
void unit_move(unitSprite *sprite);
//gint unit_collision(unitSprite *self);
void unit_remove(unitSprite *self, gint);
gint unit_is_clicked(gpointer area);

//アニメーション領域 API
myAnimeArea *
unit_anime_area_new(gint width, gint height, GdkPixmap *bg_pixmap, gint timeout);
 // 幅，高さ，背景画像，時間間隔 (ms) を指定して，
 // アニメーション領域を作る

void
unit_anime_area_remove(myAnimeArea *area);
 //アニメーション領域 area を消す

// スプライトAPI
unitSprite *
unit_sprite_new(myAnimeArea *area, gchar *path, gint timeout, GSourceFunc, GSourceFunc, gint, gint);
/* gint x, gint y は追加したもの */
 //スプライトを作成する
 // area: 作成されるスプライトがのる，アニメーション領域
 // path: 画像ファイルへのパス
 // timeout: スプライトを動かす時間間隔，
 //       描画はアニメーション領域の再描画時に行う
  
void unit_sprite_init(unitSprite *sprite);
   // スプライトの位置とベクトルの初期値を決める関数
   // 利用者が用意する

void unit_sprite_move(unitSprite *sprite);
 // スプライトを移動する関数
 // 利用者が用意する

void unit_sprite_remove(unitSprite *);
 // スプライトの消去

vector unit_aim(gint, gint);

void unit_delete(gint, gint);

# endif 
